package problem.counter;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

class Counter {
    private Integer currentValue = 0;
    public Integer next() {
        synchronized(currentValue) {
            return currentValue++;
        }
    }
}


class Counter1 {
    private static int currentValue = 0;
    public synchronized int next() {
        return ++currentValue;
    }
}

class Counter2 {
    private int currentValue = 0;
    private static Object LOCK = new Object();
    public int next() {
        synchronized(LOCK) {
            return ++currentValue;
        }
    }
}

class SomeThreadSafeClass {

    private List<String> data = Collections.synchronizedList(new ArrayList<String>());

    public void addData(String newObject) {
        data.add(newObject);
    }

    public synchronized void dumpData() {
	for(String s : data) {
            System.out.println(s);
	}
    }

}